#include <amxmodx>
#include <engine>
#include <fakemeta>
#include <murdermod>

new Float:g_fWaitTime, cvar_identity_wait, g_pCreateBodyForward;
new g_iBodyEnt[33];

public plugin_init()
{
  register_plugin("[MM] Dead Body", MM_VERSION, MM_AUTHOR);

  register_event("ClCorpse", "Message_ClCorpse", "a", "10=0");
  //register_forward(FM_EmitSound, "Forward_EmitSound"); // Allows changing identity, causes crashes :(
  cvar_identity_wait = my_register_cvar("mm_identity_wait", "5.0", "Amount of time needed to change identity. (Default: 5.0)");
  g_pCreateBodyForward = CreateMultiForward("th_spawnbody", ET_IGNORE, FP_CELL, FP_CELL);

  set_msg_block(get_user_msgid("ClCorpse"), BLOCK_SET);
}

public mm_gamemode(mode)
{
  if(mode == GAME_ENDED || mode == GAME_RESTARTING)
  {
    remove_entity_name(MM_DEAD_BODY);
    g_fWaitTime = 0.0;
  }

  if(mode == GAME_PREPARING || mode == GAME_RESTARTING)
  {
    new num;
    static players[32];
    get_players(players, num);
    for(--num; num >= 0; num--)
      g_iBodyEnt[players[num]] = false;
  }
}

public Message_ClCorpse()
{
  if(mm_get_gamemode() != GAME_STARTED)
    return;

  static Float:origin[3], model[32];
  read_data(1, model, charsmax(model));
  origin[0] = read_data(2)/128.0;
  origin[1] = read_data(3)/128.0;
  origin[2] = read_data(4)/128.0;
  new seq = read_data(9);
  new id = read_data(12);

  create_body(id, origin, model, seq);
}

public create_body(id, Float:origin[3], model[], seq)
{
  new ent = create_entity("info_target");
  g_iBodyEnt[id] = ent;
  new ret;
  ExecuteForward(g_pCreateBodyForward, ret, id, ent);
  entity_set_string(ent, EV_SZ_classname, MM_DEAD_BODY);

  static out[64];
  formatex(out, charsmax(out), "models/player/%s/%s.mdl", model, model);
  entity_set_model(ent, out);
  entity_set_origin(ent, origin);
  entity_set_size(ent, Float:{-1.0, -1.0, -1.0}, Float:{1.0, 1.0, 1.0});

  entity_set_float(ent, EV_FL_frame, 255.0);
  entity_set_int(ent, EV_INT_sequence, seq);
  entity_set_int(ent, EV_INT_movetype, MOVETYPE_FLY);
  entity_set_int(ent, EV_INT_solid, SOLID_TRIGGER);

  entity_set_int(ent, EV_INT_skin, mm_get_playerdata(id, PD_COLOR));
  entity_set_int(ent, EV_INT_iuser1, id);
}

public Forward_EmitSound(id, channel, sample[])
{
  if(!is_user_alive(id) || mm_get_gamemode() != GAME_STARTED || mm_get_playerdata(id, PD_CLASS) != CLASS_MURDERER)
    return;

  if(equal(sample, "common/wpn_denyselect.wav"))
  {
    if(mm_get_roundtime() < g_fWaitTime)
    {
      client_print_color(id, print_team_default, "%s %L", MM_TAG, id, "MM_IDENTITY2", g_fWaitTime-mm_get_roundtime());
      return;
    }

    new Float:fOrigin[2][3], origin[3];
    entity_get_vector(id, EV_VEC_origin, fOrigin[0]);
    get_user_origin(id, origin, 3);
    IVecFVec(origin, fOrigin[1]);
    if(get_distance_f(fOrigin[0], fOrigin[1]) > 60.0)
      return;

    g_fWaitTime = mm_get_roundtime() + get_pcvar_float(cvar_identity_wait);

    new ent;
    for(new i = 0; i < 33; i++)
    {
      if(is_valid_ent(i) && !is_visible(id, i))
        continue;

      if(get_dat_deadbody(g_iBodyEnt[i], fOrigin[0], fOrigin[1]))
      {
        ent = g_iBodyEnt[i];
        break;
      }
    }

    if(ent) used_use(id, ent);
  }
}

public used_use(id, ent)
{
  if(!is_user_alive(id))
    return;

  new bodyowner = entity_get_int(ent, EV_INT_iuser1);
  new Owner[PLAYERDATA], Nub[PLAYERDATA];
  
  Owner[PD_COLOR] = mm_get_playerdata(bodyowner, PD_COLOR);
  Owner[PD_NATO] = mm_get_playerdata(bodyowner, PD_NATO);  
  Nub[PD_COLOR] = mm_get_playerdata(id, PD_COLOR);
  Nub[PD_NATO] = mm_get_playerdata(id, PD_NATO);
  
  entity_set_int(ent, EV_INT_skin, Nub[PD_COLOR]);
  entity_set_int(id, EV_INT_skin, Owner[PD_COLOR]);

  client_print_color(id, print_team_default, "%s %L", MM_TAG, id, "MM_IDENTITY1", get_name(bodyowner));

  mm_set_playerdata(id, PD_COLOR, Owner[PD_COLOR]);
  mm_set_playerdata(id, PD_NATO, Owner[PD_NATO]);
  mm_set_playerdata(bodyowner, PD_COLOR, Nub[PD_COLOR]);
  mm_set_playerdata(bodyowner, PD_NATO, Nub[PD_NATO]);

}

stock get_dat_deadbody(ent, Float:startOrigin[3], Float:endOrigin[3])
{
  if(!is_valid_ent(ent))
    return false;

  //log_amx("ENT %d, return %d", ent, get_tr2(trace, TR_pHit));
  //engfunc(EngFunc_TraceLine, startOrigin, endOrigin, DONT_IGNORE_MONSTERS, id, 0);
  //get_tr2(0, TR_vecEndPos, endOrigin);
  engfunc(EngFunc_TraceModel, startOrigin, endOrigin, HULL_POINT, ent, 0);
  if(get_tr2(0, TR_pHit) == ent)
    return true;

  return false;
}
