#include <amxmodx>
#include <hamsandwich>
#include <engine>
#include <cstrike>
#include <fakemeta>
#include <murdermod>
#include <amx_settings_api>

#define XO_WEAPON                4
#define m_pPlayer               41
#define m_flNextPrimaryAttack   46
#define m_flNextSecondaryAttack 47
#define m_flTimeWeaponIdle      48

enum _:TYPE
{
  K_NONE,
  K_TEMP,
  K_ON,
  K_BOTH
}

new Array:g_aKnifeModels;
new const g_szKnifeModels[][] = {"models/v_knife.mdl", "models/p_knife.mdl", "models/murdermod/w_throwingknife.mdl"};
new const Float:g_szDroppedSize[][3] =
{
  {-20.0, -20.0, -5.0},
  {20.0, 20.0, 5.0}
};

new g_iKnifeType[33], g_iOnGround;
new g_pSmokeSprite, g_iNadeVelocity[2];
new cvar_pattack_rate, cvar_sattack_rate, cvar_pattack_recoil, cvar_sattack_recoil, cvar_knife_velocity;

public plugin_precache()
{
  new model[MM_MAXFILELENGHT];
  g_aKnifeModels = ArrayCreate(MM_MAXFILELENGHT, 3);

  if(!amx_load_setting_string_arr(MM_SETTINGSFILE, "Knife", "MODEL_V", g_aKnifeModels))
  {
    amx_save_setting_string(MM_SETTINGSFILE, "Knife", "MODEL_V", g_szKnifeModels[0]);
    precache_model(g_szKnifeModels[0]);
    ArrayPushString(g_aKnifeModels, g_szKnifeModels[0]);
  }
  else
  {
    ArrayGetString(g_aKnifeModels, 0, model, charsmax(model));
    precache_model(model);
  }

  if(!amx_load_setting_string_arr(MM_SETTINGSFILE, "Knife", "MODEL_P", g_aKnifeModels))
  {
    amx_save_setting_string(MM_SETTINGSFILE, "Knife", "MODEL_P", g_szKnifeModels[1]);
    precache_model(g_szKnifeModels[1]);
    ArrayPushString(g_aKnifeModels, g_szKnifeModels[1]);
  }
  else
  {
    ArrayGetString(g_aKnifeModels, 1, model, charsmax(model));
    precache_model(model);
  }

  if(!amx_load_setting_string_arr(MM_SETTINGSFILE, "Knife", "MODEL_W", g_aKnifeModels))
  {
    amx_save_setting_string(MM_SETTINGSFILE, "Knife", "MODEL_W", g_szKnifeModels[2]);
    precache_model(g_szKnifeModels[2]);
    ArrayPushString(g_aKnifeModels, g_szKnifeModels[2]);
  }
  else
  {
    ArrayGetString(g_aKnifeModels, 2, model, charsmax(model));
    precache_model(model);
  }

  g_pSmokeSprite = precache_model("sprites/murdermod/blacksmoke.spr");
}

public plugin_init()
{
  register_plugin("[MM] Murder knife", MM_VERSION, MM_AUTHOR);

  cvar_pattack_rate    = my_register_cvar("mm_knife_primary_rate", "0.6", "Knife primary attack rate. (Default: 0.6)");
  cvar_sattack_rate    = my_register_cvar("mm_knife_secondary_rate", "1.3", "Knife secondary attack rate. (Default: 1.3)");
  cvar_pattack_recoil  = my_register_cvar("mm_knife_primary_recoil", "-3.6", "Knife primary attack recoil. (Default: -3.6)");
  cvar_sattack_recoil  = my_register_cvar("mm_knife_secondary_recoil", "-5.0", "Knife secondary attack recoil. (Default: -5.0)");
  cvar_knife_velocity  = my_register_cvar("mm_knife_velocity", "1500", "Knife thrown velocity. (Default: 1500)");

  register_think("grenade", "Think_Grenade");
  register_touch("grenade", "*", "Touch_Grenade"); 

  register_message(get_user_msgid("TextMsg"), "Block_Text");
  register_message(get_user_msgid("SendAudio"), "Block_Audio");

  RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_hegrenade", "Ham_PrimaryAttack_Grenade_pre", 0);
  RegisterHam(Ham_Killed, "player", "Ham_Killed_pre", 0);
  RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_knife", "Ham_PrimaryAttack_post", 1);
  RegisterHam(Ham_Weapon_SecondaryAttack, "weapon_knife", "Ham_SecondaryAttack_post", 1);
  RegisterHam(Ham_Item_Deploy, "weapon_knife", "Ham_Item_Deploy_post", 1);
  RegisterHam(Ham_Item_Deploy, "weapon_hegrenade", "Ham_Item_Deploy_Grenade_post", 1);

  register_clcmd("drop", "clcmd_drop");
  register_clcmd("lastinv", "clcmd_knife");
  register_clcmd("weapon_knife", "clcmd_knife");
}

public plugin_natives()
{
  register_library("mm");
  register_native("mm_give_knife", "_give_knife");
}

public client_disconnect(id)
{
  g_iKnifeType[id] = K_NONE;
}

public mm_gamemode(mode)
{
  if(mode == GAME_ENDED || mode == GAME_RESTARTING)
    set_task(0.2, "remove_ents");

  if(mode == GAME_ENDED || mode == GAME_RESTARTING || mode == GAME_PREPARING)
  {

    new num, id;
    static players[32];
    get_players(players, num);
    for(--num; num >= 0; num--)
    {
      id = players[num];
      g_iKnifeType[id] = K_NONE;
      if(is_user_alive(id))
        reset_user_knife(id);
    }
  }
  else if(mode == GAME_STARTED)
  {
    new murderer = mm_get_classcount(CLASS_MURDERER);
    g_iKnifeType[murderer] = K_TEMP;
  }
}

public remove_ents()
{
  //remove_entity_name(MM_KNIFE_DROP);
  //remove_entity_name("grenade"); possible crash
  move_grenade();
  remove_entity_name("weaponbox");
}

public grenade_throw(id, ent, nade)
{
  if(nade == CSW_HEGRENADE && is_user_alive(id))
  {
    static Float:velocity[3];
    g_iOnGround = false;
    VelocityByAim(id, g_iNadeVelocity[0], velocity);
    if(g_iNadeVelocity[1])
    {
      static Float:origin[3];
      entity_get_vector(id, EV_VEC_origin, origin);
      origin[0] += velocity[0];
      origin[1] += velocity[1];
      entity_set_origin(ent, origin);
    }

    entity_set_vector(ent, EV_VEC_velocity, velocity);
    entity_set_int(ent, EV_INT_iuser4, id);
    entity_set_float(ent, EV_FL_nextthink, get_gametime()+0.01);
    if(get_pcvar_num(get_cvar_pointer("mm_weapon_glow")))
      UTIL_SetRendering(ent, kRenderFxGlowShell, Float:{255.0, 0.0, 0.0}, _, 50.0);

    if(entity_get_float(ent, EV_FL_dmgtime) != 0.0)
    {
      static model[MM_MAXFILELENGHT];
      ArrayGetString(g_aKnifeModels, 2, model, charsmax(model));
      entity_set_model(ent, model);
    }
  }
}

public clcmd_drop(id)
{
  if(g_iKnifeType[id] == K_ON)
  {
    clcmd_throw(id, 64, 1);
    return PLUGIN_HANDLED;
  }

  return PLUGIN_CONTINUE;
}

public clcmd_throw(id, vel, value)
{
  new ent = ham_give_weapon(id, "weapon_hegrenade", 1);
  g_iNadeVelocity[0] = vel;
  g_iNadeVelocity[1] = value;
  ExecuteHamB(Ham_Weapon_PrimaryAttack, ent);
  set_pdata_float(ent, m_flTimeWeaponIdle, 0.0, XO_WEAPON);
  ExecuteHam(Ham_Weapon_WeaponIdle, ent);
  strip_knife(id, K_NONE);

}

public clcmd_knife(id)
{
  if(g_iKnifeType[id] == K_ON)
    strip_knife(id, K_TEMP);
  else if(g_iKnifeType[id] == K_TEMP)
    strip_knife(id, K_ON);
}

public Think_Grenade(ent)
{
  if(!is_valid_ent(ent) || mm_get_gamemode() != GAME_STARTED)
    return;

  static Float:origin[3], Float:velocity[3], Float:angles[3];
  entity_get_vector(ent, EV_VEC_origin, origin);
  if(entity_get_int(ent, EV_INT_flags) & FL_ONGROUND)
  {
    if(!g_iOnGround)
    {
      entity_set_vector(ent, EV_VEC_velocity, Float:{0.0, 0.0, 0.0});
      entity_set_size(ent, g_szDroppedSize[0], g_szDroppedSize[1]);
      entity_get_vector(ent, EV_VEC_angles, angles);

      angles[0] = 270.0;
      entity_set_vector(ent, EV_VEC_angles, angles);
      if(engfunc(EngFunc_PointContents, origin) == CONTENTS_SKY)
        give_murder_knife(entity_get_int(ent, EV_INT_iuser4), ent);

      g_iOnGround = true;
    }
  }
  else
  {
    entity_get_vector(ent, EV_VEC_velocity, velocity);
    vector_to_angle(velocity, angles);
    angles[0] += 270.0;
    entity_set_vector(ent, EV_VEC_angles, angles);
    origin[2]-=15.0;
  }

  create_smoke(origin);
  if(is_valid_ent(ent))
    entity_set_float(ent, EV_FL_dmgtime, get_gametime() + 999999.0);
}

public Touch_Grenade(nade, id)
{
  if(!is_valid_ent(nade) || mm_get_gamemode() != GAME_STARTED)
    return PLUGIN_CONTINUE;

  if(is_user_alive(id))
  {
    new owner = entity_get_edict(nade, EV_ENT_owner);
    if(!owner)
    {
      if(mm_get_playerdata(id, PD_CLASS) == CLASS_MURDERER)
      {
        give_murder_knife(id, nade);
        return PLUGIN_HANDLED;
      }
    }
    else
    {
      if(owner == id)
        return PLUGIN_CONTINUE;

      emit_sound(id, CHAN_AUTO, "weapons/knife_hit4.wav", 1.0, ATTN_NORM, 0, PITCH_NORM);
      //ExecuteHam(Ham_TakeDamage, id, owner, owner, 300.0, DMG_SLASH);
      ExecuteHamB(Ham_Killed, id, owner, 0);
      entity_set_vector(nade, EV_VEC_velocity, Float:{0.0, 0.0, 0.0});
      entity_set_edict(nade, EV_ENT_owner, 0);
      drop_to_floor(nade);

      return PLUGIN_HANDLED;
    }
  }
  else
  {
    entity_set_edict(nade, EV_ENT_owner, 0);
    if(!g_iOnGround)
    {
      static Float:velocity[3];
      entity_get_vector(nade, EV_VEC_velocity, velocity);
      if(velocity[2] > 0.0)
        velocity[2] = -(velocity[2]/2.0);
      entity_set_vector(nade, EV_VEC_velocity, velocity);

      return PLUGIN_HANDLED;
    }
  }

  return PLUGIN_CONTINUE;
}

public Ham_Killed_pre(victim, killer, shouldgib)
{
  g_iKnifeType[victim] = K_NONE;
}

public Ham_PrimaryAttack_post(knife)
{
  if(!is_valid_ent(knife))
    return;

  new id = get_pdata_cbase(knife, m_pPlayer, XO_WEAPON);
  if(is_user_connected(id) && g_iKnifeType[id] == K_ON)
  {
    attack_post(id, knife, get_pcvar_float(cvar_pattack_rate), get_pcvar_float(cvar_pattack_recoil));
    clcmd_throw(id, get_pcvar_num(cvar_knife_velocity), 0);
  }
}

public Ham_SecondaryAttack_post(knife)
{
  if(!is_valid_ent(knife))
    return;

  new id = get_pdata_cbase(knife, m_pPlayer, XO_WEAPON);
  if(is_user_connected(id) && g_iKnifeType[id] == K_ON)
    attack_post(id, knife, get_pcvar_float(cvar_sattack_rate), get_pcvar_float(cvar_sattack_recoil));
}

public Ham_Item_Deploy_post(knife)
{
  if(!is_valid_ent(knife))
    return;

  new id = get_pdata_cbase(knife, m_pPlayer, XO_WEAPON);
  if(is_user_alive(id) && g_iKnifeType[id] == K_ON)
  {
    static model[MM_MAXFILELENGHT];
    ArrayGetString(g_aKnifeModels, 0, model, charsmax(model));
    entity_set_string(id, EV_SZ_viewmodel, model);
    ArrayGetString(g_aKnifeModels, 1, model, charsmax(model));
    entity_set_string(id, EV_SZ_weaponmodel, model);
    attack_post(id, knife, 0.5, 0.0);
  }
}

public Ham_Item_Deploy_Grenade_post(nade)
{
  if(!is_valid_ent(nade))
    return;

  new id = get_pdata_cbase(nade, m_pPlayer, XO_WEAPON);
  if(is_user_alive(id))
  {
    static model[MM_MAXFILELENGHT];
    ArrayGetString(g_aKnifeModels, 0, model, charsmax(model));
    entity_set_string(id, EV_SZ_viewmodel, model);
    ArrayGetString(g_aKnifeModels, 1, model, charsmax(model));
    entity_set_string(id, EV_SZ_weaponmodel, model);
    attack_post(id, nade, 0.5, 0.0);
  }
}

public Ham_PrimaryAttack_Grenade_pre(ent)
{
  set_pdata_float(ent, m_flTimeWeaponIdle, 0.0, XO_WEAPON);
  ExecuteHam(Ham_Weapon_WeaponIdle, ent);
}

public Block_Text()
{
  if(get_msg_args() != 5 || get_msg_argtype(3) != ARG_STRING || get_msg_argtype(5) != ARG_STRING)
    return PLUGIN_CONTINUE;
  
  static message[20];
  get_msg_arg_string(5, message, charsmax(message));
  if(equal(message, "#Fire_in_the_hole"))
    return PLUGIN_HANDLED;

  return PLUGIN_CONTINUE;
}

public Block_Audio()
{
  if(get_msg_args() != 3 || get_msg_argtype(2) != ARG_STRING)
    return PLUGIN_CONTINUE;

  static sound[20];
  get_msg_arg_string(2, sound, charsmax(sound));
  if(equal(sound[1], "!MRAD_FIREINHOLE"))
    return PLUGIN_HANDLED;

  return PLUGIN_CONTINUE;
}

public give_murder_knife(id, knife)
{
  pickup_weapon(id, CSW_KNIFE);
  strip_knife(id, K_ON);
  ham_give_weapon(id, "weapon_knife");
  emit_sound(id, CHAN_WEAPON, "items/gunpickup2.wav", 1.0, ATTN_NORM, 0, PITCH_NORM);
  if(is_valid_ent(knife))
    remove_entity(knife);
}

public create_smoke(Float:origin[3])
{
  message_begin_f(MSG_PVS, SVC_TEMPENTITY, origin, 0);
  write_byte(TE_SMOKE);
  write_coord_f(origin[0]);
  write_coord_f(origin[1]);
  write_coord_f(origin[2]);
  write_short(g_pSmokeSprite);
  write_byte(random_num(1, 3));
  write_byte(1);
  message_end();
}

public attack_post(id, knife, Float:flRate, Float:cvar)
{
  set_pdata_float(knife, m_flNextPrimaryAttack, flRate, XO_WEAPON);
  set_pdata_float(knife, m_flNextSecondaryAttack, flRate, XO_WEAPON);
  set_pdata_float(knife, m_flTimeWeaponIdle, flRate, XO_WEAPON);

  if(cvar > 0.0)
  {
    static Float:flPunchAngle[3];
    flPunchAngle[0] = cvar;

    entity_set_vector(id, EV_VEC_punchangle, flPunchAngle);
  }
}

public strip_knife(id, type)
{
  g_iKnifeType[id] = type;
  reset_user_knife(id);
}

public reset_user_knife(id)
{
  if(g_iKnifeType[id] == K_ON)
    mm_set_playerdata(id, PD_SHOWKNIFE, 1);
  else mm_set_playerdata(id, PD_SHOWKNIFE, 0);
  if(user_has_weapon(id, CSW_KNIFE))
    ExecuteHamB(Ham_Item_Deploy, find_ent_by_owner(-1, "weapon_knife", id));

  engclient_cmd(id, "weapon_knife");
  UTIL_PlayWeaponAnimation(id, 3);

  emessage_begin(MSG_ONE_UNRELIABLE, get_user_msgid("CurWeapon"), _, id);
  ewrite_byte(1);
  ewrite_byte(CSW_KNIFE);
  ewrite_byte(-1);
  emessage_end();
}

public _give_knife(plugin, params)
{
  if(params != 2)
    return -1;

  new id = get_param(1);
  new knife = get_param(2);
  give_murder_knife(id, knife);
  return 1;
}
