#include <amxmodx>
#include <fakemeta>
#include <engine>
#include <hamsandwich>
#include <cs_teams_api>
#include <timer_controller>
#include <amx_settings_api>
#include <murdermod>

#define LINUX_WEAPON_OFF         4
#define LINUX_PLAYER_OFF         5
#define m_pPlayer               41
#define m_flNextPrimaryAttack   46
#define m_flNextSecondaryAttack 47
#define m_iClip                 51
#define m_fInReload             54
#define m_flNextAttack          83

#define TASK_ROUNDTIME 1111

new Array:g_aPlayerNames, Trie:g_tCvarsToFile, g_iTrieSize;
new cvar_blind_time, cvar_start_smoking, cvar_weapon_glow, cvar_preparation_time, cvar_drop_deagle, cvar_player_names;
new g_pMsg_ScreeFade, g_pMsg_ScoreAttrib, g_pMsg_HideWeapon, g_pMsg_CurWeapon, g_pGameModeForward, g_pSmokeSprite;
new g_iPlayerData[33][PLAYERDATA], g_iClassIDs[CLASS], g_iGameMode;
new Float:g_fFreezeTime, Float:g_fRoundTime, Float:g_fRoundStart;
new g_szMyModels[3][MM_MAXFILELENGHT], g_szPickSounds[4][MM_MAXFILELENGHT];

public plugin_precache()
{
  new model[MM_MAXFILELENGHT];
//
  if(!amx_load_setting_string(MM_SETTINGSFILE, "MurderMod", "PLAYER_MODEL", g_szMyModels[0], charsmax(g_szMyModels[])))
  {
    g_szMyModels[0] = "murdermod";
    amx_save_setting_string(MM_SETTINGSFILE, "MurderMod", "PLAYER_MODEL", g_szMyModels[0]);
  }
  formatex(model, charsmax(model), "models/player/%s/%s.mdl", g_szMyModels[0], g_szMyModels[0]);
  precache_model(model);

  if(!amx_load_setting_string(MM_SETTINGSFILE, "MurderMod", "HANDS_MODEL", g_szMyModels[1], charsmax(g_szMyModels[])))
  {
    g_szMyModels[1] = "models/murdermod/v_kickass.mdl";
    amx_save_setting_string(MM_SETTINGSFILE, "MurderMod", "HANDS_MODEL", g_szMyModels[1]);
  }
  precache_model(g_szMyModels[1]);

  if(!amx_load_setting_string(MM_SETTINGSFILE, "MurderMod", "REVOLVER_MODEL_W", g_szMyModels[2], charsmax(g_szMyModels[])))
  {
    g_szMyModels[2] = "models/murdermod/w_colt.mdl";
    amx_save_setting_string(MM_SETTINGSFILE, "MurderMod", "REVOLVER_MODEL_W", g_szMyModels[2]);
  }
  precache_model(g_szMyModels[2]);
//
  g_pSmokeSprite = precache_model("sprites/murdermod/blacksmoke.spr");
//
  if(!amx_load_setting_string(MM_SETTINGSFILE, "MurderMod", "PICK_BYSTANDER", g_szPickSounds[1], charsmax(g_szPickSounds[])))
  {
    g_szPickSounds[1] = "murdermod/pick_bystander.wav";
    amx_save_setting_string(MM_SETTINGSFILE, "MurderMod", "PICK_BYSTANDER", g_szPickSounds[1]);
  }
  precache_sound(g_szPickSounds[1]);

  if(!amx_load_setting_string(MM_SETTINGSFILE, "MurderMod", "PICK_MURDERER", g_szPickSounds[2], charsmax(g_szPickSounds[])))
  {
    g_szPickSounds[2] = "murdermod/pick_murderer.wav";
    amx_save_setting_string(MM_SETTINGSFILE, "MurderMod", "PICK_MURDERER", g_szPickSounds[2]);
  }
  precache_sound(g_szPickSounds[2]);

  if(!amx_load_setting_string(MM_SETTINGSFILE, "MurderMod", "PICK_BYSTANDERGUN", g_szPickSounds[3], charsmax(g_szPickSounds[])))
  {
    g_szPickSounds[3] = "murdermod/pick_bystandergun.wav";
    amx_save_setting_string(MM_SETTINGSFILE, "MurderMod", "PICK_BYSTANDERGUN", g_szPickSounds[3]);
  }
  precache_sound(g_szPickSounds[3]);
//
}

public plugin_init()
{
  register_plugin("Murder Mod", MM_VERSION, MM_AUTHOR);
  register_cvar("mm_server_version", MM_VERSION, FCVAR_SERVER|FCVAR_EXTDLL|FCVAR_SPONLY);

  cvar_blind_time       = mynew_register_cvar("mm_blind_time", "30", "Time Bystander needs to wait after punishment. (Default: 30)");
  cvar_start_smoking    = mynew_register_cvar("mm_start_smoking", "60", "Time after which Murderer starts to smoke. (Default: 60)");
  cvar_weapon_glow      = mynew_register_cvar("mm_weapon_glow", "1", "Weapon glow 0/1 off/on (Default: 1)");
  cvar_preparation_time = mynew_register_cvar("mm_preparation_time", "5", "Preparation time before game start. (Default: 5)");
  cvar_drop_deagle      = mynew_register_cvar("mm_drop_deagle", "1", "Allow dropping pistol 0/1 off/on (Default: 1)");
  cvar_player_names     = mynew_register_cvar("mm_player_names", "-1", "List of player names -1/>1 random/number in list (Default: -1)");

  register_event("TextMsg", "Event_RestartRound", "a", "2&#Game_C", "2&#Game_w");
  register_event("HLTV", "Event_NewRound", "a", "1=0", "2=0");
  register_logevent("Event_StartRound", 2, "1=Round_Start");
  register_logevent("Event_EndRound", 2, "1=Round_End");
  register_touch("weaponbox", "player", "Touch_WeaponBox");
  register_forward(FM_SetModel, "Forward_SetModel");

  RegisterHamPlayer(Ham_Spawn, "Ham_Spawn_pre", 0);
  RegisterHamPlayer(Ham_Spawn, "Ham_Spawn_post", 1);
  RegisterHamPlayer(Ham_Killed, "Ham_Killed_pre", 0);
  RegisterHamPlayer(Ham_Killed, "Ham_Killed_post", 1);
  RegisterHamPlayer(Ham_TakeDamage, "Ham_TakeDamage_pre", 0);
  RegisterHam(Ham_Item_PostFrame, "weapon_deagle", "Ham_Item_PostFrame_pre", 0);
  RegisterHam(Ham_Item_Deploy, "weapon_knife", "Ham_Item_Deploy_post", 1);

  g_pMsg_ScreeFade   = get_user_msgid("ScreenFade");
  g_pMsg_ScoreAttrib = get_user_msgid("ScoreAttrib");
  g_pMsg_HideWeapon  = get_user_msgid("HideWeapon");
  g_pMsg_CurWeapon   = get_user_msgid("CurWeapon");

  g_pGameModeForward = CreateMultiForward("mm_gamemode", ET_IGNORE, FP_CELL);
  register_clcmd("drop", "clcmd_drop");
  register_dictionary("murdermod.txt");

  g_aPlayerNames = ArrayCreate(64, 26);
}

public plugin_natives()
{
  register_library("mm");
  register_native("mm_get_playerdata", "_get_playerdata");
  register_native("mm_set_playerdata", "_set_playerdata");
  register_native("mm_get_gamemode", "_get_gamemode");
  register_native("mm_set_gamemode", "_set_gamemode");
  register_native("mm_get_classcount", "_get_classcount");
  register_native("mm_get_roundtime", "_get_roundtime");
  register_native("mm_get_playername", "_get_player_name");
  register_native("mm_register_cvar", "_register_cvar");
}

public plugin_cfg()
{
  auto_exec_config(MM_CONFIGFILE);
  g_fRoundTime = get_pcvar_float(get_cvar_pointer("mp_roundtime"));
}

public client_disconnect(id)
{
  if(get_user_class(id) == CLASS_ARMED && get_game_mode() == GAME_STARTED)
  {
    new num, i;
    static players[32];
    get_players(players, num, "a");
    if(num > 2)
    {
      while(i == 0)
      {
        i = players[random(num)];
        if(get_user_class(i) != CLASS_BYSTANDER || i == id)
          i = 0;
      }
      give_deagle(i);
    }
  }
  reset_user_one(id);
}

public client_putinserver(id)
{
  reset_user_one(id);
  set_task(11.0, "startup_info", id);
}

public startup_info(id)
{
  if(get_game_mode() == GAME_STARTED && !is_user_alive(id))
  {
    set_user_class(id, CLASS_DEAD);
    update_scoreboard();
  }
  client_print_color(id, print_team_default, "%s Mod created by ^3%s^1, ^4skype:guskis1^1, ^4version: %s^1!", MM_TAG, MM_AUTHOR, MM_VERSION);
}

public clcmd_drop(id)
{
  if(get_user_pd(id, PD_CLASS) == CLASS_ARMED && !get_pcvar_num(cvar_drop_deagle))
    return PLUGIN_HANDLED;

  return PLUGIN_CONTINUE;
}

public Event_RestartRound()
{
  if(get_game_mode() != GAME_RESTARTING)
  {
    reset_user_all();
    set_game_mode(GAME_RESTARTING);
  }
}

public Event_EndRound()
{
  if(get_game_mode() != GAME_ENDED)
  {
    set_game_mode(GAME_ENDED);
    new id, num;
    static players[32];
    get_players(players, num, "a");
    for(--num; num >= 0; num--)
    {
      id = players[num];
      if(!user_has_weapon(id, CSW_KNIFE))
        ham_give_weapon(id, "weapon_knife");
      if(user_has_weapon(id, CSW_DEAGLE))
        ham_strip_weapon(id, "weapon_deagle");
    }
  }
}

public Event_NewRound()
{
  if(get_game_mode() != GAME_PREPARING)
  {
    new cvar = get_pcvar_num(cvar_preparation_time);
    if(!cvar)
      set_pcvar_num(cvar_preparation_time, cvar = 1);
    g_fFreezeTime = float(cvar);
    set_task(0.1, "set_timer");

    g_fRoundTime = get_pcvar_float(get_cvar_pointer("mp_roundtime"));
    g_fRoundStart = get_gametime();
    reset_user_all();

    set_game_mode(GAME_PREPARING);
  }
}

public set_timer()
  RoundTimerSet(0, get_pcvar_num(cvar_preparation_time));

public Event_StartRound()
{
  if(task_exists(TASK_ROUNDTIME))
    remove_task(TASK_ROUNDTIME);
  set_task(float(get_pcvar_num(cvar_preparation_time)), "do_the_magic", TASK_ROUNDTIME);
}

public do_the_magic()
{
  RoundTimerSet(floatround(g_fRoundTime));
  new num, id;
  static players[32];
  get_players(players, num, "a");

  if(num > 1)
  {
    id = players[random(num)];
    set_user_classinfo(id, CLASS_MURDERER);
    client_print_color(id, print_team_default, "%s %L", MM_TAG, id, "MM_CLASS_MURDERER", id, class_names[CLASS_MURDERER], get_player_name(id));
    pickup_weapon(id, CSW_KNIFE);

    id = 0;
    while(id == 0)
    {
      id = players[random(num)];
      if(get_user_class(id) == CLASS_MURDERER)
        id = 0;
    }

    set_user_classinfo(id, CLASS_ARMED);
    client_print_color(id, print_team_default, "%s %L", MM_TAG, id, "MM_CLASS_ARMED", id, class_names[CLASS_ARMED], get_player_name(id), id, class_names[CLASS_MURDERER]);

    for(--num; num >= 0; num--)
    {
      id = players[num];
      if(!get_user_class(id))
      {
        set_user_classinfo(id, CLASS_BYSTANDER);
        client_print_color(id, print_team_default, "%s %L", MM_TAG, id, "MM_CLASS_BYSTANDER", id, class_names[CLASS_BYSTANDER], get_player_name(id), id, class_names[CLASS_MURDERER]);
      }
    }

    get_players(players, num, "a");
    for(--num; num >= 0; num--)
    {
      message_begin(MSG_ONE_UNRELIABLE, g_pMsg_HideWeapon, _, id);
      write_byte((1<<3)+(1<<7));
      message_end();

      id = players[num];
      if(get_user_class(id) == CLASS_MURDERER)
      {
        cs_set_player_team(id, CS_TEAM_CT, false);
        set_user_task(id);
      }
      else 
      {
        if(get_user_class(id) == CLASS_ARMED)
          give_deagle(id);
        cs_set_player_team(id, CS_TEAM_T, false);
      }
      entity_set_int(id, EV_INT_skin, get_user_pd(id, PD_COLOR));
      set_fake_team(id);
      if(get_user_class(id) < 4)
        client_cmd(id, "spk ^"%s^"", g_szPickSounds[get_user_class(id)]);
      //ham_give_weapon(id, "weapon_knife");
    }
    set_game_mode(GAME_STARTED);
  }
  else
  {
    set_game_mode(GAME_UNSET);
    client_print_color(0, print_team_default, "%s %L", MM_TAG, LANG_PLAYER, "MM_MODOFF");
  }
}

public Touch_WeaponBox(ent, id)
{
  if(get_game_mode() != GAME_STARTED)
    return PLUGIN_HANDLED;
  if(!(entity_get_int(ent, EV_INT_flags) & FL_ONGROUND))
    return PLUGIN_CONTINUE;

  if(is_user_alive(id))
  {
    if(get_user_pd(id, PD_CANTPICK))
      return PLUGIN_HANDLED;
    
    if(get_user_class(id) == CLASS_BYSTANDER)
      set_user_class(id, CLASS_ARMED);
    else if(get_user_class(id) == CLASS_MURDERER)
      return PLUGIN_HANDLED;

    if(get_user_weapon(id) != CSW_DEAGLE)
    {
      pickup_weapon(id, CSW_DEAGLE);
      cs_set_user_bpammo(id, CSW_DEAGLE, 6);
    }
  }

  return PLUGIN_CONTINUE;
}

public Forward_SetModel(ent, model[])
{
  if(!is_valid_ent(ent))
    return FMRES_IGNORED;

  static classname[32];
  entity_get_string(ent, EV_SZ_classname, classname, charsmax(classname));
  if(!equal(classname, "weaponbox"))
    return FMRES_IGNORED;

  if(equal(model, "models/w_deagle.mdl"))
  {
    new id = entity_get_edict(ent, EV_ENT_owner);
    entity_set_model(ent, g_szMyModels[2]);

    if(is_user_alive(id))
      set_user_class(id, CLASS_BYSTANDER);
    if(get_pcvar_num(cvar_weapon_glow))
      UTIL_SetRendering(ent, kRenderFxGlowShell, Float:{0.0, 0.0, 255.0}, _, 50.0);

    return FMRES_SUPERCEDE;
  }

  return FMRES_IGNORED;
}

public Ham_Spawn_pre(id) 
{
  if(is_user_connected(id))
  {
    set_attrib_all(id, 0);
    set_fake_team(id);
  }
}

public Ham_Spawn_post(id) 
{
  if(is_user_alive(id))
  {
    strip_weapons(id);
    if(get_game_mode() != GAME_UNSET)
    {  
      static model[20];
      cs_get_user_model(id, model, charsmax(model));
      if(!equal(model, g_szMyModels[0]))
        cs_set_user_model(id, g_szMyModels[0]);
    }
  }
}

public Ham_Killed_pre(victim, killer, shouldgib)
{
  if(get_game_mode() != GAME_STARTED)
    return HAM_IGNORED;

  new vicClass, kilClass;
  if(is_user_connected(victim))
    vicClass = get_user_class(victim);
  if(is_user_connected(killer))
    kilClass = get_user_class(killer);

  if(vicClass == CLASS_ARMED)
    cs_set_user_bpammo(victim, CSW_DEAGLE, 0);

  if(kilClass == CLASS_ARMED)
  {
    if(vicClass == CLASS_BYSTANDER)
    {
      set_user_pd(killer, PD_CANTPICK, 1);
      set_task(0.1, "drop_deagle", killer);
      client_print_color(killer, print_team_default, "%s %L", MM_TAG, killer, "MM_KILLED_WRONG", killer, class_names[vicClass], get_player_name(victim));
    }
    else if(vicClass == CLASS_MURDERER)
      client_print_color(killer, print_team_default, "%s %L", MM_TAG, killer, "MM_KILLED_RIGHT", killer, class_names[vicClass], get_player_name(victim));
  }
  else if(kilClass == CLASS_MURDERER && killer != victim)
  {
    set_user_task(killer);
    client_print_color(killer, print_team_default, "%s %L", MM_TAG, killer, "MM_KILLED_RIGHT", killer, class_names[vicClass], get_player_name(victim));
  }

  if(is_user_connected(killer) && killer != victim)
  {
    if(kilClass != CLASS_MURDERER)
      set_user_pd(killer, PD_KILLED, victim);
    else set_user_pd(killer, PD_KILLED, get_user_pd(killer, PD_KILLED)+1);

    static name[32];
    get_user_name(killer, name, charsmax(name));
    client_print_color(victim, print_team_default, "%s %L", MM_TAG, victim, "MM_KILLED_BY", victim, class_names[kilClass], get_player_name(killer), name);
  }
  else client_print_color(victim, print_team_default, "%s %L", MM_TAG, victim, "MM_KILLED_SUICIDE");

  return HAM_HANDLED;
}

public Ham_Killed_post(victim, killer, shouldgib)
{
  set_user_class(victim, CLASS_DEAD);
  set_task(0.1, "update_scoreboard");
}

public update_scoreboard()
{
  if(get_game_mode() != GAME_STARTED)
    return;

  new num, i, userclass;
  static players[32];
  get_players(players, num);
  for(--num; num >= 0; num--)
  {
    i = players[num];
    userclass = get_user_class(i);
    if(userclass == CLASS_DEAD || userclass == CLASS_NONE)
    {
      set_attrib_one(i, 0, CLASS_ARMED, CLASS_BYSTANDER);
      set_attrib_one(i, 1, CLASS_MURDERER, CLASS_NONE, CLASS_DEAD);
    }
  }
}

public drop_deagle(id)
{
  if(!is_user_alive(id) || get_game_mode() != GAME_STARTED)
    return;

  if(get_user_weapon(id) != CSW_DEAGLE)
    engclient_cmd(id, "weapon_deagle");
  engclient_cmd(id, "drop", "weapon_deagle");

  message_begin(MSG_ONE_UNRELIABLE, g_pMsg_ScreeFade, _, id);
  write_short(get_pcvar_num(cvar_blind_time) * 1<<12);
  write_short(4*1<<12);
  write_short(0x0000);
  write_byte(0);
  write_byte(0);
  write_byte(0);
  write_byte(255);
  message_end();
}

public Ham_Item_PostFrame_pre(ent) 
{
  if(!is_valid_ent(ent))
    return HAM_IGNORED;

  new id = get_weapon_owner(ent);
  if(!is_user_connected(id))
    return HAM_IGNORED;

  if(get_pdata_float(ent, m_fInReload, LINUX_WEAPON_OFF) && (get_pdata_float(id, m_flNextAttack, LINUX_PLAYER_OFF) <= 0.0))
  {
    cs_set_user_bpammo(id, CSW_DEAGLE, 6);
    set_pdata_int(ent, m_iClip, 1, LINUX_WEAPON_OFF);
    set_pdata_float(ent, m_fInReload, 0.0, LINUX_WEAPON_OFF);
  }

  return HAM_HANDLED;
}

public Ham_Item_Deploy_post(ent)
{
  if(!is_valid_ent(ent))
    return;

  new id = get_weapon_owner(ent);
  if(!is_user_connected(id))
    return;

  if(!get_user_pd(id, PD_SHOWKNIFE))
  {
    new Float:time = 9999.9;
    set_pdata_float(ent, m_flNextPrimaryAttack, time, LINUX_WEAPON_OFF);
    set_pdata_float(ent, m_flNextSecondaryAttack, time, LINUX_WEAPON_OFF);

    //play_weapon_anim(id, 0);
    entity_set_string(id, EV_SZ_viewmodel, g_szMyModels[1]);
    entity_set_string(id, EV_SZ_weaponmodel, "");
  }
}

public Ham_TakeDamage_pre(victim, inflictor, attacker, Float:damage, DamageBits)
{
  if(is_user_alive(attacker))
  {
    damage *= 30.0;

    SetHamParamFloat(4, damage);
    return HAM_HANDLED;
  }

  return HAM_IGNORED;
}

stock set_attrib_one(id, msg, class1, class2=-1, class3=-1, class4=-1)
{
  if(!is_user_connected(id))
    return;

  new num, i, userclass;
  static players[32];
  get_players(players, num);
  for(--num; num >= 0; num--)
  {
    i = players[num];
    userclass = get_user_class(i);

    if(userclass == class1 || userclass == class2 || userclass == class3 || userclass == class4)
    {
      message_begin(MSG_ONE_UNRELIABLE, g_pMsg_ScoreAttrib, _, i);
      write_byte(id);
      write_byte(msg);
      message_end();
    }
  }
}

stock set_attrib_all(id, msg)
{
  if(!is_user_connected(id))
    return;

  message_begin(MSG_BROADCAST, g_pMsg_ScoreAttrib);
  write_byte(id);
  write_byte(msg);
  message_end();
}

stock get_user_class(id)
  return g_iPlayerData[id][PD_CLASS];

stock set_user_class(id, newclass)
{

  if(newclass == CLASS_MURDERER || newclass == CLASS_ARMED)
    g_iClassIDs[newclass] = id;
  else g_iClassIDs[newclass]++;

  new oldclass = g_iPlayerData[id][PD_CLASS];
  if(oldclass == CLASS_MURDERER || oldclass == CLASS_ARMED)
    g_iClassIDs[oldclass] = 0;
  else g_iClassIDs[oldclass]--;

  g_iPlayerData[id][PD_CLASS] = newclass;
}

stock get_class_count(class)
  return g_iClassIDs[class];

stock get_user_pd(id, pd)
  return g_iPlayerData[id][pd];

stock set_user_pd(id, pd, value)
{
  if(pd == PD_CLASS)
    set_user_class(id, value);
  else g_iPlayerData[id][pd] = value;
}

stock get_game_mode()
  return g_iGameMode;

stock set_game_mode(value)
{
  if(g_iGameMode && value == GAME_RESTARTING)
    log_amx("[MM] Game has restarted :(");

  g_iGameMode = value;
  new ret;
  ExecuteForward(g_pGameModeForward, ret, value);
}

stock reset_user_all()
{
  new num, id;
  static players[32];
  get_players(players, num);

  for(--num; num >= 0; num--)
  {
    id = players[num];
    reset_user_one(id);
  }
}

stock reset_user_one(id)
{
  new i;
  for(i = 0; i < PLAYERDATA; i++)
    set_user_pd(id, i, 0);

  if(task_exists(id))
    remove_task(id);
}

stock get_weapon_owner(ent)
  return get_pdata_cbase(ent, m_pPlayer, LINUX_WEAPON_OFF);

stock play_weapon_anim(id, anim)
{
  if(!is_user_alive(id))
    return;

  entity_set_int(id, EV_INT_weaponanim, anim);
  message_begin(MSG_ONE_UNRELIABLE, SVC_WEAPONANIM, .player = id);
  write_byte(anim);
  write_byte(entity_get_int(id, EV_INT_body));
  message_end();
}

stock set_user_classinfo(id, value)
{
  set_user_class(id, value);
  set_user_pd(id, PD_STARTCLASS, value);
  set_user_pd(id, PD_NATO, random(MM_MAXNAMES-1));
  set_user_pd(id, PD_COLOR, random(charsmax(g_szNatoColor)));
}

stock Float:get_roundtime()
  return get_gametime() - g_fRoundStart - g_fFreezeTime;

stock set_user_task(id)
{
  if(task_exists(id))
    remove_task(id);

  new cvar = get_pcvar_num(cvar_start_smoking);
  set_user_pd(id, PD_SMOKETIME, cvar);
  set_task(float(cvar), "start_smoking", id);
}

stock give_deagle(id)
{
  new weapon = ham_give_weapon(id, "weapon_deagle");
  cs_set_user_bpammo(id, CSW_DEAGLE, 6);
  cs_set_weapon_ammo(weapon, 1);
  switch_knife(id);
  pickup_weapon(id, CSW_DEAGLE);
}

stock switch_knife(id)
{
  ExecuteHamB(Ham_Item_Deploy, find_ent_by_owner(-1, "weapon_knife", id));
  engclient_cmd(id, "weapon_knife");
  UTIL_PlayWeaponAnimation(id, 0);
  emessage_begin(MSG_ONE_UNRELIABLE, g_pMsg_CurWeapon, _, id);
  ewrite_byte(1);
  ewrite_byte(CSW_KNIFE);
  ewrite_byte(-1);
  emessage_end();
}

stock get_player_name(id)
{
  static cvar;
  if(!cvar)
  {
    cvar = get_pcvar_num(cvar_player_names);
    if(!cvar)
      cvar = -1;
    
    if(cvar == -1)
    {
      new max;
      if(!amx_load_setting_int(MM_SETTINGSFILE, "player_names", "max_id", max))
      {
        static const szPlayerNames[] =
        {
          "Alpha, Kilo, Uniform, Bravo, Lima, Victor, Charlie, Mike, Whiskey, \
          Delta, November, Xray, Echo, Oscar, Yankee, Foxtrot, Papa, Zulu, \
          Golf, Quebec, Hotel, Romeo, India, Sierra, Juliet, Tango"
        };
        amx_save_setting_int(MM_SETTINGSFILE, "player_names", "max_id", 1);
        amx_save_setting_string(MM_SETTINGSFILE, "player_names", "1", szPlayerNames);
        cvar = 1;
      }
      else cvar = random_num(1, max);
    }
  }

  static check;
  if(!check)
  {
    static szCvar[3];
    num_to_str(cvar, szCvar, charsmax(szCvar));
    amx_load_setting_string_arr(MM_SETTINGSFILE, "player_names", szCvar, g_aPlayerNames);
    check = true;
  }

  static hisname[64];
  new nameid = get_user_pd(id, PD_NATO);
  ArrayGetString(g_aPlayerNames, nameid, hisname, charsmax(hisname));
  return hisname;
}

public start_smoking(id)
  set_task(0.5, "create_smoke", id, _, _, "b");

public create_smoke(id)
{
  if(!is_user_alive(id))
  {
    remove_task(id);
    return;
  }

  static Float:origin[3];
  entity_get_vector(id, EV_VEC_origin, origin);

  message_begin_f(MSG_PVS, SVC_TEMPENTITY, origin, 0);
  write_byte(TE_SMOKE);
  write_coord_f(origin[0]);
  write_coord_f(origin[1]);
  write_coord_f(origin[2]);
  write_short(g_pSmokeSprite);
  write_byte(random_num(2, 5));
  write_byte(1);
  message_end();
}

stock mynew_register_cvar(name[], string[], description[], flags = 0, Float:fvalue = 0.0)
{
  new_register_cvar(name, string, description);
  return register_cvar(name, string, flags, fvalue);
}

stock new_register_cvar(name[], string[], description[], plug[] = "mm_main.amxx")
{
  static path[96];
  if(!path[0])
  {
    get_localinfo("amxx_configsdir", path, charsmax(path));
    format(path, charsmax(path), "%s/%s", path, MM_CONFIGFILE);
  }

  new file;
  if(!g_tCvarsToFile)
    g_tCvarsToFile = TrieCreate();

  if(!file_exists(path))
  {
    file = fopen(path, "wt");
    if(!file)
      return 0;

    fprintf(file, "// Server specific.^n");
    fprintf(file, "%-32s %-8s // %-32s // %s^n", "mp_tkpunish", "0",        plug, "Disables TeamKill punishments");
    fprintf(file, "%-32s %-8s // %-32s // %s^n", "mp_friendlyfire", "1",      plug, "Enables friendly fire to attack teamnates");
    fprintf(file, "%-32s %-8s // %-32s // %s^n", "mp_limitteams", "0",        plug, "Disables team limits");
    fprintf(file, "%-32s %-8s // %-32s // %s^n", "mp_autoteambalance", "0",      plug, "Disables team limits");
    fprintf(file, "%-32s %-8s // %-32s // %s^n", "mp_freezetime", "0",        plug, "Disables freeze time on round start");
    fprintf(file, "%-32s %-8s // %-32s // %s^n", "mp_playerid", "2",        plug, "Disables team info when aiming on player");
    fprintf(file, "%-32s %-8s // %-32s // %s^n", "sv_alltalk", "1",        plug, "Enables alltalk");
    fprintf(file, "%-26s %-14s // %-32s // %s^n", "amx_statscfg", "off PlayerName",  plug, "Disables player name when aiming on player");
    fprintf(file, "^n");
    fprintf(file, "// Mod specific.^n");
  }
  else
  {
    file = fopen(path, "rt");
    if(!file)
      return 0;

    //if(!TrieGetSize(g_tCvarsToFile))
    if(!g_iTrieSize)
    {
      new newline[48];
      static line[128];
      while(!feof(file))
      {
        fgets(file, line, charsmax(line));
        if(line[0] == ';' || !line[0])
          continue;

        parse(line, newline, charsmax(newline));
        remove_quotes(newline);
        #if AMXX_VERSION_NUM >= 183
          TrieSetCell(g_tCvarsToFile, newline, 1, false);
        #else
          TrieSetCell(g_tCvarsToFile, newline, 1);
        #endif
        g_iTrieSize++;
      }
    }
    fclose(file);
    file = fopen(path, "at");
  }

  if(!TrieKeyExists(g_tCvarsToFile, name))
  {
    fprintf(file, "%-32s %-8s // %-32s // %s^n", name, string, plug, description);
    #if AMXX_VERSION_NUM >= 183
      TrieSetCell(g_tCvarsToFile, name, 1, false);
    #else
      TrieSetCell(g_tCvarsToFile, name, 1);
    #endif
    g_iTrieSize++;
  }

  fclose(file);
  return 1;
}

// API
public _get_playerdata(plugin, params)
{
  if(params != 2)
    return -1;

  new id = get_param(1);
  new pd = get_param(2);

  return get_user_pd(id, pd);
}

public _set_playerdata(plugin, params)
{
  if(params != 3)
    return -1;

  new id = get_param(1);
  new pd = get_param(2);
  new value = get_param(3);
  set_user_pd(id, pd, value);

  return 1;
}

public _get_gamemode(plugin, params)
  return get_game_mode();

public _set_gamemode(plugin, params)
{
  if(params != 1)
    return -1;

  new value = get_param(1);
  set_game_mode(value);
  return value;
}


public _get_classcount(plugin, params)
{
  if(params != 1)
    return -1;

  new class = get_param(1);
  return get_class_count(class);
}

public Float:_get_roundtime(plugin, params)
  return get_roundtime();

public _get_player_name(plugin, params)
{
  if(params != 2)
    return -1;

  set_string(2, get_player_name(get_param(1)), MM_MAXFILELENGHT-1);
  return 1;
}

public _register_cvar(plugin, params)
{
  if(params != 3)
    return -1;

  static name[48], string[16], pluginname[48], description[128];
  get_string(1, name, charsmax(name));
  get_string(2, string, charsmax(string));
  get_string(3, description, charsmax(description));
  get_plugin(plugin, pluginname, charsmax(pluginname));

  return new_register_cvar(name, string, description, pluginname);
}
