#include <amxmodx>
#include <fun>
#include <murdermod>

new const g_szWinner[][] =
{
  "",
  "MM_BWIN",
  "MM_MWIN"
};
new g_iInfo[2], g_iCached;

public plugin_init()
{
  register_plugin("[MM] Motds", MM_VERSION, MM_AUTHOR);

  register_clcmd("rules_main", "show_motd_help");
  register_clcmd("rules_other", "show_motd_help_other");
  register_clcmd("say /help", "show_motd_help");
  register_clcmd("say_team /help", "show_motd_help");
}

public mm_winner(team)
{
  g_iInfo[0] = team;
  g_iInfo[1] = mm_get_classcount(CLASS_MURDERER);
  g_iCached = 0;
  new num, id;
  static players[32];
  get_players(players, num);
  for(--num; num >= 0; num--)
  {
    id = players[num];
    client_cmd(id, "-attack");
    set_task(0.1, "show_motd_winner", id);
  }
}

public show_motd_help_other(id)
  show_motd(id, "addons\amxmodx\configs\mm_other.html", "Other rules");

public show_motd_help(id)
{
  new len;
  const SIZE = 1536;
  static msg[SIZE+1], motdname[64];
  len += formatex(msg[len], SIZE - len, "<html><head><meta charset='utf-8'></head><body bgcolor='#ebf3f8'>");
  len += formatex(msg[len], SIZE - len, "<a style='color:#A30000'><b>%L</b><br>", id, "MM_HELP_LINE2");
  len += formatex(msg[len], SIZE - len, "%L<br>", id, "MM_HELP_LINE3");
  len += formatex(msg[len], SIZE - len, "%L<br>", id, "MM_HELP_LINE4");
  len += formatex(msg[len], SIZE - len, "%L<br>", id, "MM_HELP_LINE5");
  len += formatex(msg[len], SIZE - len, "%L<br>", id, "MM_HELP_LINE6");
  len += formatex(msg[len], SIZE - len, "%L<br>", id, "MM_HELP_LINE7");
  len += formatex(msg[len], SIZE - len, "<b>%L</b><br>", id, "MM_HELP_LINE8");
  len += formatex(msg[len], SIZE - len, "%L<br>", id, "MM_HELP_LINE9");
  len += formatex(msg[len], SIZE - len, "%L<br>", id, "MM_HELP_LINE10");
  len += formatex(msg[len], SIZE - len, "<b>%L</b><br>", id, "MM_HELP_LINE11");
  len += formatex(msg[len], SIZE - len, "%L<br>", id, "MM_HELP_LINE12");
  len += formatex(msg[len], SIZE - len, "%L<br>", id, "MM_HELP_LINE13");
  len += formatex(msg[len], SIZE - len, "%L<br>", id, "MM_HELP_LINE14");
  len += formatex(msg[len], SIZE - len, "</body></html>");
  formatex(motdname, charsmax(motdname), "%L", id, "MM_HELP_LINE1");
  show_motd(id, msg, motdname);
}

public show_motd_winner(id)
{
  if(!is_user_connected(id) || mm_get_gamemode() == GAME_UNSET)
    return;

  const SIZE = 1536;
  static msg[SIZE+1], motdname[64], name[32], out[32];
  if(!g_iCached)
  {
    new len, murderer = g_iInfo[1], killed;
    get_user_name(murderer, name, charsmax(name));
    new natoC = mm_get_playerdata(murderer, PD_COLOR);
    new classN = mm_get_playerdata(murderer, PD_STARTCLASS);
    new count = mm_get_playerdata(murderer, PD_KILLED);

    parse_me_rgb(natoC, out, charsmax(out));

    len += formatex(msg[len], SIZE - len, "<html><head><meta charset='utf-8'><style>body{background:#000000 no-repeat center top;color:#FFFFFF}</style></head><body>");
    len += formatex(msg[len], SIZE - len, "</br><center><h2 style='color:%s'>%L</h2></center>", g_iInfo[0] == CLASS_MURDERER ? out : "#FFFFFF", id, g_szWinner[g_iInfo[0]]);
    len += formatex(msg[len], SIZE - len, "<b style='color:%s'>%L %s (%s) killed %d %Ls</b></br></br>", out, id, class_names[classN], get_name(murderer), name, count, id, class_names[CLASS_BYSTANDER]);

    new num, i;
    static players[32];
    get_players(players, num);
    for(--num; num >= 0; num--)
    {
      i = players[num];
      if(i == murderer)
        continue;

      if((killed = mm_get_playerdata(i, PD_KILLED)))
      {
        get_user_name(i, name, charsmax(name));
        natoC = mm_get_playerdata(i, PD_COLOR);
        classN = mm_get_playerdata(i, PD_STARTCLASS);
        parse_me_rgb(natoC, out, charsmax(out));
        len += formatex(msg[len], SIZE - len, "<b style='color:%s'>%L %s (%s)</b> killed", out, id, class_names[classN], get_name(i), name);

        get_user_name(killed, name, charsmax(name));
        natoC = mm_get_playerdata(killed, PD_COLOR);
        classN = mm_get_playerdata(killed, PD_STARTCLASS);
        parse_me_rgb(natoC, out, charsmax(out));
        len += formatex(msg[len], SIZE - len, " <b style='color:%s'>%L %s (%s)</b></br>", out, id, class_names[classN], get_name(killed), name);
      }
    }
    
    len += formatex(msg[len], SIZE - len, "</body></html>");
    g_iCached = true;
  }
  show_motd(id, msg, motdname);
}

stock parse_me_rgb(color, out[], size)
{
  static szRGB[3][4];
  parse(g_szNatoColor[color], szRGB[0], charsmax(szRGB[]), szRGB[1], charsmax(szRGB[]), szRGB[2], charsmax(szRGB[]));
  formatex(out, size, "rgb(%s,%s,%s)", szRGB[0], szRGB[1], szRGB[2]);
}
