#include <amxmodx>
#include <cstrike>
#include <fakemeta>
#include <hamsandwich>
#include <amx_settings_api>
#include <mm_const>

new const g_sBlockSet[][] =
{
  "BombDrop",
  "BombPickup",
  "DeathMsg",
  "WeapPickup",
  "ScoreInfo",
  "AmmoPickup",
  "Money"
};

new const g_sMessageBlock[][] =
{
  "ScoreAttrib",
  "TextMsg",
  "SendAudio",
  "Scenario",
  "StatusIcon"
};

new g_szColtModels[2][MM_MAXFILELENGHT];

public plugin_precache()
{
  if(!amx_load_setting_string(MM_SETTINGSFILE, "MurderMod", "REVOLVER_MODEL_V", g_szColtModels[0], charsmax(g_szColtModels[])))
  {
    g_szColtModels[0] = "models/murdermod/v_colt.mdl";
    amx_save_setting_string(MM_SETTINGSFILE, "MurderMod", "REVOLVER_MODEL_V", g_szColtModels[0]);
  }
  precache_model(g_szColtModels[0]);

  if(!amx_load_setting_string(MM_SETTINGSFILE, "MurderMod", "REVOLVER_MODEL_P", g_szColtModels[1], charsmax(g_szColtModels[])))
  {
    g_szColtModels[1] = "models/murdermod/p_colt.mdl";
    amx_save_setting_string(MM_SETTINGSFILE, "MurderMod", "REVOLVER_MODEL_P", g_szColtModels[1]);
  }
  precache_model(g_szColtModels[1]);

  new sound[MM_MAXFILELENGHT];
  if(!amx_load_setting_string(MM_SETTINGSFILE, "MurderMod", "REVOLVER_SOUND_DRAW", sound, charsmax(sound)))
  {
    sound = "weapons/bull_draw.wav";
    amx_save_setting_string(MM_SETTINGSFILE, "MurderMod", "REVOLVER_SOUND_DRAW", sound);
  }
  precache_sound(sound);

  if(!amx_load_setting_string(MM_SETTINGSFILE, "MurderMod", "REVOLVER_SOUND_RELOAD", sound, charsmax(sound)))
  {
    sound = "weapons/bull_reload.wav";
    amx_save_setting_string(MM_SETTINGSFILE, "MurderMod", "REVOLVER_SOUND_RELOAD", sound);
  }
  precache_sound(sound);
}

public plugin_init()
{
  register_plugin("[MM] Replacements", MM_VERSION, MM_AUTHOR);

  new i;
  for(i = 0; i <= charsmax(g_sBlockSet); i++)
    set_msg_block(get_user_msgid(g_sBlockSet[i]), BLOCK_SET);

  for(i = 0; i <= charsmax(g_sMessageBlock); i++)
    register_message(get_user_msgid(g_sMessageBlock[i]), "Message_Block");

  RegisterHam(Ham_Item_Deploy, "weapon_deagle", "Ham_Knife_Deploy_post", 1);
  register_forward(FM_EmitSound, "Forward_EmitSound_pre", 0);
  register_forward(FM_GetGameDescription, "Forward_GetGameDescription_pre", 0);
}

public Message_Block(msgid, dest, id)
{
  if(get_msg_args() > 1)
  {
    static message[128];
    if(get_msg_args() == 5)
      get_msg_arg_string(5, message, charsmax(message));

    if(equal(message, "#Fire_in_the_hole"))
      return PLUGIN_HANDLED;

    get_msg_arg_string(2, message, charsmax(message));
    if(equal(message, "%!MRAD_BOMBPL") || equal(message, "%!MRAD_BOMBDEF") || equal(message, "%!MRAD_terwin") || equal(message, "%!MRAD_ctwin") || equal(message, "%!MRAD_FIREINHOLE"))
      return PLUGIN_HANDLED;

    if(equal(message, "#Killed_Teammate") || equal(message, "#Game_teammate_kills") || equal(message, "#Game_teammate_attack") || equal(message, "#C4_Plant_At_Bomb_Spot"))
      return PLUGIN_HANDLED;

    if(equal(message, "#Bomb_Planted") || equal(message, "#Game_bomb_drop") || equal(message, "#Game_bomb_pickup") || equal(message, "#Got_bomb") || equal(message, "#C4_Plant_Must_Be_On_Ground"))
      return PLUGIN_HANDLED;
  }

  return PLUGIN_CONTINUE;
}

public Forward_GetGameDescription_pre()
{
  forward_return(FMV_STRING, "Murder Mod");
  return FMRES_SUPERCEDE;
}

public Forward_EmitSound_pre(id, channel, sample[])
{
  if(!is_user_connected(id))
    return FMRES_IGNORED;

  if(equal(sample, "player/die", 10) || equal(sample, "player/death6.wav") || equal(sample, "weapons/knife_deploy1.wav"))
    return FMRES_SUPERCEDE;

  return FMRES_IGNORED;
}

public Ham_Knife_Deploy_post(ent)
{
  if(pev_valid(ent))
  {
    new id = get_weapon_owner(ent);
    if(is_user_alive(id))
    {
      set_pev(id, pev_viewmodel2, g_szColtModels[0]);
      set_pev(id, pev_weaponmodel2, g_szColtModels[1]);
    }
  }
}

stock get_weapon_owner(ent)
  return get_pdata_cbase(ent, 41, 4);
