#include <amxmodx>
#include <murdermod>
#include <amx_settings_api>
#include <round_terminator>

#define TASK_ROUNDEND 1111

new g_iWonGame, g_pMsg_TeamScore;
new g_iWonScore[CLASS], g_pWonForward;

new const g_szWinSounds[3][MM_MAXFILELENGHT];
new const g_szWinner[][] =
{
  "",
  "MM_BWIN",
  "MM_MWIN"
};

public plugin_precache()
{
  if(!amx_load_setting_string(MM_SETTINGSFILE, "Winner sounds", "BYSTANDER", g_szWinSounds[1], charsmax(g_szWinSounds[])))
  {
    g_szWinSounds[1] = "murdermod/win_bystander.wav";
    amx_save_setting_string(MM_SETTINGSFILE, "Winner sounds", "BYSTANDER", g_szWinSounds[1]);
  }
  precache_sound(g_szWinSounds[1]);

  if(!amx_load_setting_string(MM_SETTINGSFILE, "Winner sounds", "MURDERER", g_szWinSounds[2], charsmax(g_szWinSounds[])))
  {
    g_szWinSounds[2] = "murdermod/win_murderer.wav";
    amx_save_setting_string(MM_SETTINGSFILE, "Winner sounds", "MURDERER", g_szWinSounds[2]);
  }
  precache_sound(g_szWinSounds[2]);
}

public plugin_init()
{
  register_plugin("[MM] Round winner", MM_VERSION, MM_AUTHOR);

  register_message(get_user_msgid("TextMsg"), "Message_Winner");
  g_pMsg_TeamScore = get_user_msgid("TeamScore");
  g_pWonForward = CreateMultiForward("mm_winner", ET_IGNORE, FP_CELL);
}

public plugin_natives()
{
  register_library("mm");
  register_native("mm_get_winner", "_get_winner");
  register_native("mm_set_winner", "_set_winner");
}

public mm_gamemode(mode)
{
  if(mode != GAME_STARTED && task_exists(TASK_ROUNDEND))
    remove_task(TASK_ROUNDEND);

  switch(mode)
  {
    case GAME_RESTARTING:
    {
      g_iWonGame = false;
      g_iWonScore[CLASS_MURDERER] = 0;
      g_iWonScore[CLASS_BYSTANDER] = 0;
    }
    case GAME_PREPARING:
    {
      set_task(floatmul(get_pcvar_float(get_cvar_pointer("mp_roundtime")), 60.0), "End_Round_False", TASK_ROUNDEND);
      g_iWonGame = false;
    }
  }

  set_task(0.2, "Update_Scores");
}

public client_disconnect(id)
{
  if(get_winner())
    End_Round_False();
  else if(mm_get_playerdata(id, PD_CLASS) == CLASS_MURDERER)
    End_Round_False();
}

public client_putinserver(id)
{
  if(mm_get_gamemode() == GAME_UNSET)
  {
    new total, alive;
    static players[32];
    get_players(players, total);
    get_players(players, alive, "a");

    if(total > 2 || alive == 1)
      set_task(0.1, "restart_already");
  }
}

public restart_already()
  if(mm_get_gamemode() == GAME_UNSET)
    set_pcvar_num(get_cvar_pointer("sv_restartround"), 3);

public End_Round_False()
{
  if(mm_get_gamemode() == GAME_STARTED || mm_get_gamemode() == GAME_UNSET)
    TerminateRound(RoundEndType_TeamExtermination, CLASS_BYSTANDER, MapType_Bomb);
}

public get_winner()
{
  new who, num;
  static players[32];

  get_players(players, num, "a");
  if(num <= 0)
    who = CLASS_MURDERER;
  else if(mm_get_classcount(CLASS_BYSTANDER) == 0 && mm_get_classcount(CLASS_ARMED) == 0)
    who = CLASS_MURDERER;
  else if(mm_get_classcount(CLASS_MURDERER) == 0)
    who = CLASS_BYSTANDER;

  return who;
}

public Message_Winner(msgid, dest, id)
{
  if(mm_get_gamemode() != GAME_STARTED || g_iWonGame)
    return PLUGIN_CONTINUE;
  
  static message[20];
  get_msg_arg_string(2, message, charsmax(message));
  if(equal(message, "#Terrorists_Win") || equal(message, "#CTs_Win"))
  {
    new who;
    if(equal(message, "#Terrorists_Win"))
      who = CLASS_BYSTANDER;
    else if(equal(message, "#CTs_Win"))
      who = CLASS_MURDERER;

    if(!who)
      who = get_winner();

    if(who)
    {
      g_iWonGame = who;
      g_iWonScore[who]++;
      static out[32];
      formatex(out, charsmax(out), "%L", LANG_PLAYER, g_szWinner[g_iWonGame]);
      set_msg_arg_string(2, out);
      client_cmd(0, "spk ^"%s^"", g_szWinSounds[g_iWonGame]);
      //emit_sound(0, CHAN_AUTO, g_szWinSounds[g_iWonGame], VOL_NORM, ATTN_NORM, 0, PITCH_NORM);
      new ret;
      ExecuteForward(g_pWonForward, ret, g_iWonGame);
      
      //mm_set_gamemode(GAME_ENDED);
      return PLUGIN_HANDLED;
    }
  }

  return PLUGIN_CONTINUE;
}

public Update_Scores()
{
  message_begin(MSG_BROADCAST, g_pMsg_TeamScore);
  write_string("TERRORIST");
  write_short(g_iWonScore[CLASS_BYSTANDER]);
  message_end();

  message_begin(MSG_BROADCAST, g_pMsg_TeamScore);
  write_string("CT");
  write_short(g_iWonScore[CLASS_MURDERER]);
  message_end();

  //g_iWonGame = false;
}

public _get_winner()
  return g_iWonGame;

public _set_winner(plugin, params)
{
  if(params != 1)
    return 1;

  new team = get_param(1);
  if(team != CLASS_BYSTANDER && team != CLASS_MURDERER)
    return -1;

  g_iWonGame = team;
  g_iWonScore[team]++;

  TerminateRound(RoundEndType_TeamExtermination, team);
  
  return team;
}
