#include <amxmodx>
#include <engine>
#include <murdermod>

new g_pStatusSync, g_pScreenSync, g_pMurderSmoke;

public plugin_init()
{
  register_plugin("[MM] Status info", MM_VERSION, MM_AUTHOR);

  register_event("StatusValue", "Event_StatusValue_S", "be", "1=2", "2!0");
  register_event("StatusValue", "Event_StatusValue_H", "be", "1=1", "2=0");

  g_pStatusSync  = CreateHudSyncObj();
  g_pScreenSync  = CreateHudSyncObj();
  g_pMurderSmoke = CreateHudSyncObj();
}

public client_putinserver(id)
  if(!task_exists(id))
    set_task(1.0, "show_screen", id, _, _, "b");

public client_disconnect(id)
{
  if(task_exists(id))
    remove_task(id);
}

public Event_StatusValue_S(id)
{
  if(!is_user_connected(id) || mm_get_gamemode() != GAME_STARTED)
    return;

  new pid = read_data(2);
  new szRGB[3][4];
  parse(g_szNatoColor[mm_get_playerdata(pid, PD_COLOR)], szRGB[0], charsmax(szRGB[]), szRGB[1], charsmax(szRGB[]), szRGB[2], charsmax(szRGB[]));

  set_hudmessage(str_to_num(szRGB[0]), str_to_num(szRGB[1]), str_to_num(szRGB[2]), -1.0, 0.60, 0, 0.0, 1.1, 0.0, 0.0, -1);
  ShowSyncHudMsg(id, g_pStatusSync, "%s", get_name(pid));
}

public Event_StatusValue_H(id)
  ClearSyncHud(id, g_pStatusSync);

public show_screen(alive)
{
  if(mm_get_gamemode() != GAME_STARTED && mm_get_gamemode() != GAME_ENDED)
    return;

  new dead = alive;
  if(!is_user_alive(dead))
  {
    alive = entity_get_int(dead, EV_INT_iuser2);
    if(!is_user_alive(alive))
      return;
  }

  new szRGB[3][4];
  parse(g_szNatoColor[mm_get_playerdata(alive, PD_COLOR)], szRGB[0], charsmax(szRGB[]), szRGB[1], charsmax(szRGB[]), szRGB[2], charsmax(szRGB[]));

  set_hudmessage(str_to_num(szRGB[0]), str_to_num(szRGB[1]), str_to_num(szRGB[2]), 0.02, 0.85, 0, 0.0, 1.1, 0.0, 0.0, -1);

  if(!is_user_alive(dead))
    ShowSyncHudMsg(dead, g_pScreenSync, "%s", get_name(alive));
  else ShowSyncHudMsg(alive, g_pScreenSync, "%L %s", alive, class_names[mm_get_playerdata(alive, PD_CLASS)], get_name(alive));

  if(mm_get_classcount(CLASS_MURDERER) != dead || mm_get_gamemode() == GAME_ENDED)
    return;

  new time = mm_get_playerdata(dead, PD_SMOKETIME);
  if(time)
  {
    mm_set_playerdata(dead, PD_SMOKETIME, --time);
    set_hudmessage(255, 50, 0, 0.02, 0.2, 0, 0.0, 1.1, 0.0, 0.0, -1);
    ShowSyncHudMsg(dead, g_pMurderSmoke, "[TIME - %d]", time);
  }
}
