#include <amxmodx>
#include <engine>
#include <fakemeta>
#include <mm_const>

public plugin_init()
{
  register_plugin("[MM] Voice", MM_VERSION, MM_AUTHOR);
  register_forward(FM_Voice_SetClientListening, "Forward_SetClientListening");
}

public Forward_SetClientListening(receiver, sender, bool:listen)
{
  if(!is_user_connected(receiver) || !is_user_connected(sender) || sender == receiver)
    return FMRES_IGNORED;

  if(get_speak(sender) == SPEAK_MUTED)
  {
    engfunc(EngFunc_SetClientListening, receiver, sender, false);
    return FMRES_SUPERCEDE;
  }

  switch(is_user_alive(sender))
  {
    case 1: // ALIVE
    {
      listen = true;
    }
    case 0: // NOT ALIVE
    {
      if(is_user_alive(receiver))
        listen = false;
      else listen = true;
    }
  }

  engfunc(EngFunc_SetClientListening, receiver, sender, listen);
  return FMRES_SUPERCEDE;
}
